unit Main;

interface

uses
  WinTypes, WinProcs, SysUtils, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus, ExtCtrls, PlusMemo, Buttons;

type
  TFrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Save1: TMenuItem;
    PanToolbar: TPanel;
    SpeedBtnUnderline: TSpeedButton;
    SpeedBtnItalic: TSpeedButton;
    SpeedBtnBold: TSpeedButton;
    SpeedBtnPaste: TSpeedButton;
    SpeedBtnCopy: TSpeedButton;
    SpeedBtnCut: TSpeedButton;
    SpeedBtnPrint: TSpeedButton;
    SpeedBtnSearch: TSpeedButton;
    SpeedBtnSave: TSpeedButton;
    SpeedBtnOpen: TSpeedButton;
    Edit1: TMenuItem;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    N2: TMenuItem;
    SelectAll1: TMenuItem;
    Word1: TMenuItem;
    Search1: TMenuItem;
    Help1: TMenuItem;
    AboutNotepadPlus1: TMenuItem;
    Setup1: TMenuItem;
    Font1: TMenuItem;
    FontDialog1: TFontDialog;
    BackgroundColor1: TMenuItem;
    HighlightText1: TMenuItem;
    ColorDialog1: TColorDialog;
    HighlightBackgroundColor1: TMenuItem;
    SpeedBtnHighlight: TSpeedButton;
    PanStatus: TPanel;
    LblPar: TLabel;
    LblOffset: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    LblLine: TLabel;
    LblCol: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LblProgress: TLabel;
    Find1: TMenuItem;
    FindNext1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    Toolbar1: TMenuItem;
    Statusbar1: TMenuItem;
    N5: TMenuItem;
    TextFormat1: TMenuItem;
    SpeedBtnAltFont: TSpeedButton;
    AlternateFont1: TMenuItem;
    N6: TMenuItem;
    Print1: TMenuItem;
    CaretWidth1: TMenuItem;
    N7: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Center1: TMenuItem;
    Justified1: TMenuItem;
    FindDialog1: TFindDialog;
    Undo1: TMenuItem;
    N8: TMenuItem;
    SpeedButton1: TSpeedButton;
    PlusMemo1: TPlusMemo;
    Syntax1: TMenuItem;
    MnuKeywordsNone: TMenuItem;
    MnuKeywordsDelphi: TMenuItem;
    MnuKeywordsCustom: TMenuItem;
    N9: TMenuItem;
    CustomSetup1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Cut1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SpeedBtnBoldClick(Sender: TObject);
    procedure SpeedBtnItalicClick(Sender: TObject);
    procedure SpeedBtnUnderlineClick(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SelectAll1Click(Sender: TObject);
    procedure Word1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure BackgroundColor1Click(Sender: TObject);
    procedure HighlightText1Click(Sender: TObject);
    procedure HighlightBackgroundColor1Click(Sender: TObject);
    procedure SpeedBtnHighlightClick(Sender: TObject);
    procedure PlusMemo1Progress(Sender: TObject);
    procedure PlusMemo1StyleChange(Sender: TObject);
    procedure PlusMemo1SelMove(Sender: TObject);
    procedure AboutNotepadPlus1Click(Sender: TObject);
    procedure Find1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Toolbar1Click(Sender: TObject);
    procedure Statusbar1Click(Sender: TObject);
    procedure TextFormat1Click(Sender: TObject);
    procedure SpeedBtnAltFontClick(Sender: TObject);
    procedure AlternateFont1Click(Sender: TObject);
    procedure SpeedBtnPrintClick(Sender: TObject);
    procedure CaretWidth1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Center1Click(Sender: TObject);
    procedure Justified1Click(Sender: TObject);
    procedure FindDialog1Find(Sender: TObject);
    procedure FindNext1Click(Sender: TObject);
    procedure Undo1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure PanToolbarDblClick(Sender: TObject);
    procedure MnuKeywordsNoneClick(Sender: TObject);
    procedure MnuKeywordsDelphiClick(Sender: TObject);
    procedure MnuKeywordsCustomClick(Sender: TObject);
    procedure CustomSetup1Click(Sender: TObject);
    procedure PanToolbarClick(Sender: TObject);
 private
    { Private-dclarations }
    fEditFile: string;
    procedure setEditFile(const name: string);
 public
    OutputRTFFormat: Boolean;
    DelphiKeywords, CustomKeywords: TKeywordList;
    DelphiStartStopKeys: TStartStopKeyList;
    property EditFile: String read fEditFile write setEditFile;

    procedure LoadFile(const fname: string);
    procedure PlusMemo1LoadProgress(Sender: TObject);
    procedure PlusMemo1SaveProgress(Sender: TObject);
    { Public-dclarations }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}
uses About, Clipbrd, IniFiles, Printers, Custom 
     {$IFNDEF WIN32}(*{$IFDEF DEBUG}*), WinCrt (*{$ENDIF}*){$ENDIF};

const MainSection = 'Window';
      ViewSection = 'View';
      FontSection = 'Font';
      ColorsSection='Colors';
      EditionSection='Edition';
      SetupSection  ='Setup';
      CustomKeywordsSection = 'Custom Keywords';

      {$IFNDEF VER100} crHandPoint = crUpArrow; {$ENDIF}

type skeyinfo = packed record Options: TWordOptions;
                              Style: TExtFontStyles;
                              ContextNumber: Smallint
                              end;

procedure TFrmMain.FormCreate(Sender: TObject);
var Inif : TIniFile;
    fsint: Byte;
    i    : Integer;
    klist: TStringList;
    key  : string;
    keypos: Integer;
    keyval: skeyinfo;
begin
DelphiKeywords:= TKeywordList.Create;
PlusMemo1.Keywords.Free;
PlusMemo1.Keywords:= nil;
with DelphiKeywords do
  begin
  Delimiters:= [' ', '.', '(', ')', ':', '=', ';', '^', '+', '-',
                ',', '*', '/', '{', '}', '<', '>'];
  BeginUpdate;
  AddKeyWord('begin', [woWholeWordsOnly], [fsBold], 1, crDefault, clWhite, clNavy);
  AddKeyWord('end'  , [woWholeWordsOnly], [fsBold], 1, crDefault, clWhite, clNavy);
  AddKeyWord('if'   , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('then' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('else' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('for'  , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('to'   , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('downto', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('with' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('var'  , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('type' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('string' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('record' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('case' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('of'   , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('const', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('while', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('do'   , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('class', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('private', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('protected', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('public', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('published', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('property', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('inherited' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('message', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('raise'  , [woWholeWordsOnly], [fsBold], 1, crDefault, clRed, clWhite);
  AddKeyWord('uses'   , [woWholeWordsOnly], [fsBold], 1, crDefault, clDkGray, clWhite);
  AddKeyWord('not'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('in'     , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('and'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('or'     , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('xor'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('div'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('nil'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('shl'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('shr'    , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('constructor', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('destructor', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('override', [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('virtual' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('packed'  , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('dynamic' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('try'     , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('except'  , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('finally' , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('repeat'  , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);
  AddKeyWord('until'   , [woWholeWordsOnly], [fsBold], 1, crDefault, 0, 0);

  AddKeyWord('procedure', [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clWhite, clRed);
  AddKeyWord('function' , [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clWhite, clRed);
  AddKeyWord('unit'     , [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clSilver, clRed);
  AddKeyWord('program'  , [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clSilver, clRed);
  AddKeyWord('implementation', [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clSilver, clRed);
  AddKeyWord('interface', [woWholeWordsOnly], [fsBold, fsUnderline], 1, crDefault, clSilver, clRed);
  EndUpdate
  end;

with PlusMemo1.StartStopKeys do
  begin
  AddStartStopKey('{', '}', [woMatchCase], [fsItalic], 1, crDefault, clWhite, clBlue, False);
  AddStartStopKey('(*', '*)', [woMatchCase], [fsItalic], 1, crDefault, clWhite, clGreen, False);
  AddStartStopKey('''', '''', [woMatchCase], [], 1, crDefault, clLtGray, clBlack, True);
  AddStartStopKey('//', '', [woMatchCase], [fsItalic], 1, crDefault, clWhite, clFuchsia, False)
  end;

Inif:= TIniFile.Create(ExtractFilePath(Application.ExeName)+'notepadp.ini');
with Inif do
    begin
    { load general settings }
    Width:= ReadInteger(MainSection, 'Width', Width);
    Height:= ReadInteger(MainSection, 'Height', Height);
    Top:= ReadInteger(MainSection, 'Top', (Screen.Height-Height) div 2);
    Left:= ReadInteger(MainSection, 'Left', (Screen.Width - Width) div 2);
    WindowState:= TWindowState(ReadInteger(MainSection, 'State', ord(wsNormal)));

    PanToolbar.Visible:= ReadBool(ViewSection, 'ToolBar', True);
    PanStatus.Visible:=  ReadBool(ViewSection, 'Status', True);
    Toolbar1.Checked:= PanToolbar.Visible;
    Statusbar1.Checked:= PanStatus.Visible;

    { load custom keywords }
    CustomKeywords:= TKeywordList.Create;
    key:= ReadString(MainSection, 'Custom delimiters', '..,;: []{}()');
    with CustomKeywords do
      for i:= 2 to Length(key) do
        Delimiters:= Delimiters + [key[i]];
    klist:= TStringList.Create;
    ReadSectionValues(CustomKeywordsSection, klist);
    CustomKeywords.BeginUpdate;
    for i:= 0 to klist.Count-1 do
      begin
      key:= klist[i];
      keypos:= Pos('=', key);
      Longint(keyval):= StrToInt(Copy(key, keypos+1, Length(key)-keypos));
      CustomKeywords.AddKeyword(Copy(key, 1, keypos-1), keyval.Options, keyval.Style,
                                                        keyval.ContextNumber,
                                                        crHandPoint,
                                                        0, 0);
      end;
    klist.Free;
    CustomKeywords.EndUpdate;

    key:= ReadString(MainSection, 'Syntax', 'None');
    if key='None' then begin
                       PlusMemo1.ApplyKeywords:= False;
                       PlusMemo1.ApplyStartStopKeys:= False;
                       MnuKeywordsNone.Checked:= True
                       end;
    if key='Delphi' then
      begin
      PlusMemo1.Keywords:= DelphiKeywords;
      PlusMemo1.ApplyKeywords:= True;
      PlusMemo1.ApplyStartStopKeys:= True;
      MnuKeywordsDelphi.Checked:= True
      end;
    if key='Custom' then
      begin
      PlusMemo1.Keywords:= CustomKeywords;
      PlusMemo1.ApplyKeywords:= True;
      PlusMemo1.ApplyStartStopKeys:= False;
      MnuKeywordsCustom.Checked:= True
      end;

    { load PlusMemo settings }
    with PlusMemo1 do
      begin
      Font.Name:= ReadString(FontSection, 'Type', 'Arial');
      Font.Size:= ReadInteger(FontSection, 'Size', 10);
      fsint:= ReadInteger(FontSection, 'Style', 0);
      Font.Style:= TFontStyles(fsint);
      Font.Color:= ReadInteger(FontSection, 'Color', clBlack);
      AltFont.Name:= ReadString(FontSection, 'AlternateType', 'Courier New');
      AltFont.Size:= ReadInteger(FontSection, 'AlternateSize', 10);
      SpeedBtnAltFont.Font.Name:= PlusMemo1.AltFont.Name;

      Color:=  ReadInteger(ColorsSection, 'Background', clWindow);
      HighlightColor:= ReadInteger(ColorsSection, 'Highlight text', clRed);
      HighlightBackgnd:= ReadInteger(ColorsSection, 'Highlight backgrnd', clYellow);

      EnableHotKeys:= ReadBool(EditionSection, 'Text formatting', True);
      TextFormat1.Checked:= PlusMemo1.EnableHotKeys;

      WordWrap:= ReadBool(SetupSection, 'Word wrap', True);
      if WordWrap then begin ScrollBars:= ssVertical; UpdateMode:= umBackground end
                  else begin ScrollBars:= ssBoth; UpdateMode:= umOnNeed end;
      Word1.Checked:= WordWrap;

      CaretWidth:= ReadInteger(SetupSection, 'Caret width', 0);

      case TAlignment(ReadInteger(SetupSection, 'Alignment',
                                   ord(taLeftJustify))) of
        taLeftJustify: Left1Click(Self);
        taRightJustify: Right1Click(Self);
        taCenter      : Center1Click(Self)
        end;
      Justified:= ReadBool(SetupSection, 'Justified', False);
      Justified1.Checked:= Justified
      end;  { with PlusMemo1 }

    Free
    end;   { with Inif }

if ParamCount>0 then LoadFile(ParamStr(1))
                else EditFile:=''
end;    { FormCreate }

procedure TFrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
var Inif    : TIniFile;
    fsint   : Byte;
    InifName: string;
    key     : string;
    i       : Integer;
    keyval  : TKeywordInfo;
    keyvals : sKeyInfo;
    c       : Char;
begin
DelphiKeywords.Free;
PlusMemo1.Keywords:= nil;
InifName:= ExtractFilePath(Application.ExeName)+'notepadp.ini';
Inif:= TIniFile.Create(InifName);
with Inif do
    begin
    { save general settings }
    WriteInteger(MainSection, 'Width', Width);
    WriteInteger(MainSection, 'Height', Height);
    WriteInteger(MainSection, 'Top', Top);
    WriteInteger(MainSection, 'Left', Left);
    WriteInteger(MainSection, 'State', ord(WindowState));

    WriteBool(ViewSection, 'ToolBar', PanToolbar.Visible);
    WriteBool(ViewSection, 'Status', PanStatus.Visible);

    if MnuKeywordsNone.Checked then key:= 'None';
    if MnuKeywordsDelphi.Checked then key:= 'Delphi';
    if MnuKeywordsCustom.Checked then key:= 'Custom';
    WriteString(MainSection, 'Syntax', key);

    { save custom keywords }
    EraseSection(CustomKeywordsSection);
    with CustomKeywords do
      if Count>0 then
        begin
        key:= '.';
        for c:= #1 to #255 do if c in Delimiters then key:= key + c;
        WriteString(MainSection, 'Custom delimiters', key);
        for i:= 0 to Count-1 do
          begin
          keyval:= KeyInfos[i];
          keyvals.Options:= keyval.Options;
          keyvals.Style:= keyval.Style;
          keyvals.ContextNumber:= keyval.ContextNumber;
          WriteInteger(CustomKeywordsSection, Strings[i], Longint(keyvals))
          end
        end;
    CustomKeywords.Free;

    { save PlusMemo settings }
    with PlusMemo1 do
      begin
      WriteString(FontSection, 'Type', Font.Name);
      WriteInteger(FontSection, 'Size', Font.Size);
      TFontStyles(fsint):= Font.Style;
      WriteInteger(FontSection, 'Style', fsint);
      WriteInteger(FontSection, 'Color', Font.Color);
      WriteString(FontSection, 'AlternateType', AltFont.Name);
      WriteInteger(FontSection, 'AlternateSize', AltFont.Size);

      WriteInteger(ColorsSection, 'Background', Color);
      WriteInteger(ColorsSection, 'Highlight text', HighlightColor);
      WriteInteger(ColorsSection, 'Highlight backgrnd', HighlightBackgnd);
      WriteBool(EditionSection, 'Text formatting', EnableHotKeys);
      WriteBool(SetupSection, 'Word wrap', WordWrap);
      WriteInteger(SetupSection, 'Caret width', CaretWidth);
      WriteInteger(SetupSection, 'Alignment', ord(Alignment));
      WriteBool(SetupSection, 'Justified', Justified)
      end;  { with PlusMemo1 }

    Free
    end;   { with Inif }

end;  { FormClose }

procedure TFrmMain.setEditFile(const name: string);
  begin
  fEditFile:= name;
  if name<>'' then Caption:= 'Notepad Plus - ' + ExtractFileName(name)
              else Caption:= 'Notepad Plus - Untitled';
  Application.Title:= Caption
  end;

var FileStream: TFileStream;
procedure TFrmMain.LoadFile(const fname: string);
begin
  EditFile:= fname;
  FileStream:= TFileStream.Create(fname, fmOpenRead);
  try
    with PlusMemo1 do
    begin
      OnProgress:= PlusMemo1LoadProgress;
      LoadFromStream(FileStream);
      OnProgress:= PlusMemo1Progress;
      Modified:= False;
      LblProgress.Hide
    end;
  finally
    FileStream.Destroy
    end;
  PlusMemo1SelMove(Self);
  PlusMemo1StyleChange(Self);
end;

procedure TFrmMain.PlusMemo1LoadProgress;
  begin
  with FileStream do
    begin
    LblProgress.Show;
    LblProgress.Caption:= 'loading ' + IntToStr((Position *100) div Size) + '%';
    if Position>=Size-1 then PlusMemo1.OnProgress:= PlusMemo1Progress
    end;
  LblProgress.Update
  end;

procedure TFrmMain.PlusMemo1SaveProgress;
  begin
  LblProgress.Show;
  with FileStream do
    LblProgress.Caption:= 'saving ' + IntToStr((Size*100) div PlusMemo1.CharCount) + '%';
  LblProgress.Update
  end;

procedure TFrmMain.Cut1Click(Sender: TObject);
begin
PlusMemo1.CutToClipboard
end;

procedure TFrmMain.Paste1Click(Sender: TObject);
begin
PlusMemo1.PasteFromClipboard
end;

procedure TFrmMain.Copy1Click(Sender: TObject);
begin
PlusMemo1.CopyToClipboard
end;

procedure TFrmMain.Save1Click(Sender: TObject);
begin
if EditFile='' then SaveAs1Click(Save1);
if EditFile<>'' then
  with PlusMemo1 do
    begin
      OnProgress:= PlusMemo1SaveProgress;
      FileStream:= TFileStream.Create(EditFile, fmCreate);
      try
        if OutputRTFFormat then SaveToRTFStream(FileStream, False)
                           else SaveToStream(FileStream);
        Modified:= False;
      finally
        FileStream.Destroy
        end;
      OnProgress:= PlusMemo1Progress
    end
end;

procedure TFrmMain.SaveAs1Click(Sender: TObject);
var ext: string;
begin
if SaveDialog1.Execute then
  begin
  EditFile:= SaveDialog1.FileName;
  ext:= UpperCase(ExtractFileExt(EditFile));
  if (ext='') and (EditFile[Length(EditFile)]<>'.') then
      EditFile:= EditFile+'.TXT';
  OutputRTFFormat:= ext='.RTF'; {SaveDialog1.FilterIndex=2;}
  Save1Click(SaveAs1)
  end
end;

procedure TFrmMain.New1Click(Sender: TObject);
var canDiscard: Boolean;
begin
  FormCloseQuery(New1, canDiscard);
  if canDiscard then
    begin
      PlusMemo1.Clear;
      EditFile:= '';
      PlusMemo1.Modified:= False;
    end
end;

procedure TFrmMain.Open1Click(Sender: TObject);
var canDiscard: Boolean;
begin
  FormCloseQuery(Open1, canDiscard);
  if canDiscard then
    if OpenDialog1.Execute then  LoadFile(OpenDialog1.FileName);
end;

procedure TFrmMain.SpeedBtnBoldClick(Sender: TObject);
begin
  PlusMemo1.SetBold;
  SpeedBtnBold.Down:= fsBold in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnItalicClick(Sender: TObject);
begin
  PlusMemo1.SetItalic;
  SpeedBtnItalic.Down:= fsItalic in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnUnderlineClick(Sender: TObject);
begin
  PlusMemo1.SetUnderline;
  SpeedBtnUnderline.Down:= fsUnderline in PlusMemo1.SelStyle;
end;

procedure TFrmMain.SpeedBtnHighlightClick(Sender: TObject);
begin
  PlusMemo1.SetHighlight;
  SpeedBtnHighlight.Down:= fsHighlight in PlusMemo1.SelStyle
end;

procedure TFrmMain.SpeedBtnAltFontClick(Sender: TObject);
begin
PlusMemo1.SetAltFont;
SpeedBtnAltFont.Down:= fsAltFont in PlusMemo1.SelStyle
end;

procedure TFrmMain.Exit1Click(Sender: TObject);
begin
  Close
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
CanClose:= True;
if PlusMemo1.Modified then
      case MessageDlg('Save changes to "' + ExtractFileName(EditFile) + '"?',
                       mtConfirmation, mbYesNoCancel, 0)
        of mrYes: Save1Click(Self);
           mrCancel: CanClose:= False
        end
end;

procedure TFrmMain.SelectAll1Click(Sender: TObject);
begin
  PlusMemo1.SelectAll
end;

procedure TFrmMain.Word1Click(Sender: TObject);
begin
  with PlusMemo1 do
    begin
      Wordwrap:= not Wordwrap;
      Word1.Checked:= Wordwrap;
      if WordWrap then
        begin
        ScrollBars:= ssVertical;
        UpdateMode:= umBackground
        end
      else begin ScrollBars:= ssBoth; UpdateMode:= umOnNeed end
    end
end;

procedure TFrmMain.Font1Click(Sender: TObject);
begin
  FontDialog1.Font:= PlusMemo1.Font;
  if FontDialog1.Execute then PlusMemo1.Font:= FontDialog1.Font
end;

procedure TFrmMain.AlternateFont1Click(Sender: TObject);
begin
  FontDialog1.Font:= PlusMemo1.AltFont;
  if FontDialog1.Execute then
    begin
    PlusMemo1.AltFont:= FontDialog1.Font;
    SpeedBtnAltFont.Font.Name:= FontDialog1.Font.Name
    end
end;


procedure TFrmMain.BackgroundColor1Click(Sender: TObject);
begin
  ColorDialog1.Color:= PlusMemo1.Color;
  if ColorDialog1.Execute then PlusMemo1.Color:= ColorDialog1.Color
end;

procedure TFrmMain.HighlightText1Click(Sender: TObject);
begin
  ColorDialog1.Color:= PlusMemo1.HighlightColor;
  if ColorDialog1.Execute then PlusMemo1.HighlightColor:= ColorDialog1.Color
end;

procedure TFrmMain.HighlightBackgroundColor1Click(Sender: TObject);
begin
  ColorDialog1.Color:= PlusMemo1.HighlightBackgnd;
  if ColorDialog1.Execute then PlusMemo1.HighlightBackgnd:= ColorDialog1.Color
end;

procedure TFrmMain.PlusMemo1Progress(Sender: TObject);
begin
  LblProgress.Show;
  LblProgress.Caption:= 'formatting ' + IntToStr(PlusMemo1.FormatCompleted) +'%';
  {Enabled:= False;}
  LblProgress.Update;
  {Application.ProcessMessages;
  Enabled:= True }
end;

procedure TFrmMain.PlusMemo1StyleChange(Sender: TObject);
var fs: TExtFontStyles;
begin
  fs:= PlusMemo1.SelStyle;
  SpeedBtnBold.Down:= fsBold in fs;
  SpeedBtnItalic.Down:= fsItalic in fs;
  SpeedBtnUnderline.Down:= fsUnderline in fs; 
  SpeedBtnHighlight.Down:= fsHighlight in fs;
  SpeedBtnAltFont.Down:= fsAltFont in fs
end;

procedure TFrmMain.PlusMemo1SelMove(Sender: TObject);
begin
  LblProgress.Hide;
  with PlusMemo1 do
    begin
      LblOffset.Caption:= IntToStr(SelStart);
      LblPar.Caption   := IntToStr(SelPar+1);
      LblLine.Caption  := IntToStr(SelLine+1);
      LblCol.Caption   := IntToStr(SelCol+1)
    end
end;

procedure TFrmMain.AboutNotepadPlus1Click(Sender: TObject);
begin
AboutBox.Show
end;

procedure TFrmMain.Find1Click(Sender: TObject);
begin
FindDialog1.Execute
end;


procedure TFrmMain.Toolbar1Click(Sender: TObject);
begin
with PanToolbar do
  begin
  Visible:= not Visible;
  Toolbar1.Checked:= Visible
  end
end;

procedure TFrmMain.Statusbar1Click(Sender: TObject);
begin
with PanStatus do
  begin
  Visible:= not Visible;
  Statusbar1.Checked:= Visible
  end
end;

procedure TFrmMain.TextFormat1Click(Sender: TObject);
begin
with PlusMemo1 do
  begin
  EnableHotKeys:= not EnableHotKeys;
  TextFormat1.Checked:= EnableHotKeys
  end
end;


procedure TFrmMain.SpeedBtnPrintClick(Sender: TObject);
  { Print the content of PlusMemo1 with left margin  = 1.25 inch
                                        right margin = 0.75 inch
                                        top margin   = 1.25 inch
                                        bottom marg. =  0.5 inch }
var i, slen, sstart: Longint;
    p: TPoint;
    XSize, YSize: Integer;
    XPPI, YPPI  : Integer;
begin
{if not PrintDialog1.Execute then Exit;}
slen:= PlusMemo1.SelLength;
sstart:= PlusMemo1.SelStart;
PlusMemo1.SelLength:= 0;
Printer.Title:= 'Notepad Plus';
Printer.BeginDoc;
with Printer.Canvas do
  begin
  XSize:= GetDeviceCaps(Handle, HORZRES);
  YSize:= GetDeviceCaps(Handle, VERTRES);
  XPPI := GetDeviceCaps(Handle, LOGPIXELSX);
  YPPI := GetDeviceCaps(Handle, LOGPIXELSY);
  end;

PlusMemo1.FormatText(Printer.Canvas, XSize-2*XPPI); 

p.X:= Round(1.25*XPPI);
p.Y:= 0;
for i:= 0 to PlusMemo1.LineCount-1 do
  begin
  if p.Y= 0 then  { print header }
    with Printer.Canvas do
      begin
      Font.Name:= 'COURIER NEW';
      Font.Size:= 12;
      TextOut(Round(XPPI*1.25), Round(YPPI*0.5), EditFile);
      p.Y:= Round(YPPI*1.25)
      end;

  PlusMemo1.DrawLine(i, Printer.Canvas, p);
  p.Y:= p.Y + Round(PlusMemo1.LineHeight*1.5);
  if p.Y>YSize-Round(0.5*YPPI) then
    begin        { eject this page and start new one }
    p.Y:= 0;
    if i<PlusMemo1.LineCount-1 then
      begin
      Printer.EndDoc;
      Printer.BeginDoc
      end
    end
  end;

PlusMemo1.FormatText(nil, 100);  { return PlusMemo1 in its former state }
Printer.EndDoc;
PlusMemo1.SelStart:= sstart;
PlusMemo1.SelLength:= slen
end;

procedure TFrmMain.CaretWidth1Click(Sender: TObject);
var cwstr: string;
begin
cwstr:= IntToStr(PlusMemo1.CaretWidth);
if InputQuery('Setting caret width', 'Enter the new value (0 means auto width)',
               cwstr) then
    PlusMemo1.CaretWidth:= StrToInt(cwstr)
end;

procedure TFrmMain.Right1Click(Sender: TObject);
begin
PlusMemo1.Alignment:= taRightJustify;
Right1.Checked:= True;
Left1.Checked:= False;
Center1.Checked:= False;
end;

procedure TFrmMain.Left1Click(Sender: TObject);
begin
PlusMemo1.Alignment:= taLeftJustify;
Right1.Checked:= False;
Left1.Checked:= True;
Center1.Checked:= False;
end;

procedure TFrmMain.Center1Click(Sender: TObject);
begin
PlusMemo1.Alignment:= taCenter;
Right1.Checked:= False;
Left1.Checked:= False;
Center1.Checked:= True;
end;

procedure TFrmMain.Justified1Click(Sender: TObject);
begin
Justified1.Checked:= not Justified1.Checked;
PlusMemo1.Justified:= Justified1.Checked
end;

procedure TFrmMain.FindDialog1Find(Sender: TObject);
begin
Screen.Cursor:= crHourGlass;
with FindDialog1 do
  if PlusMemo1.FindText(FindText, frDown in Options, frMatchCase in Options) then
      PlusMemo1.ScrollInView
  else ShowMessage('Search string not found');
Screen.Cursor:= crDefault;
SetFocus;
FindNext1.Enabled:= True
end;

procedure TFrmMain.FindNext1Click(Sender: TObject);
begin
FindDialog1Find(FindNext1)
end;

procedure TFrmMain.Undo1Click(Sender: TObject);
begin
PlusMemo1.Undo
end;

procedure TFrmMain.Edit1Click(Sender: TObject);
begin
Undo1.Enabled:= PlusMemo1.CanUndo
end;

procedure TFrmMain.PanToolbarDblClick(Sender: TObject);
begin
PlusMemo1.ApplyKeyWords:= not PlusMemo1.ApplyKeyWords
end;

procedure TFrmMain.MnuKeywordsNoneClick(Sender: TObject);
begin
if MnuKeywordsNone.Checked then Exit;
MnuKeywordsNone.Checked:= True;
MnuKeywordsCustom.Checked:= False;
MnuKeywordsDelphi.Checked:= False;
PlusMemo1.ApplyKeywords:= False;
PlusMemo1.ApplyStartStopKeys:= False;
PlusMemo1.ReApplyKeywords;
end;

procedure TFrmMain.MnuKeywordsDelphiClick(Sender: TObject);
begin
if MnuKeywordsDelphi.Checked then Exit;
MnuKeywordsDelphi.Checked:= True;
MnuKeywordsCustom.Checked:= False;
MnuKeywordsNone.Checked:= False;
with PlusMemo1 do
  begin
  Keywords:= DelphiKeywords;
  ApplyKeywords:= True;
  ApplyStartStopKeys:= True;
  ReApplyKeywords
  end;
end;

procedure TFrmMain.MnuKeywordsCustomClick(Sender: TObject);
begin
if MnuKeywordsCustom.Checked then Exit;
MnuKeywordsCustom.Checked:= True;
MnuKeywordsDelphi.Checked:= False;
MnuKeywordsNone.Checked:= False;
with PlusMemo1 do
  begin
  Keywords:= CustomKeywords;
  ApplyKeywords:= True;
  ApplyStartStopKeys:= False;
  ReApplyKeywords
  end;
end;

procedure TFrmMain.CustomSetup1Click(Sender: TObject);
var i: Integer; k: TKeywordInfo;
begin
if EditKeywordList(CustomKeywords) then
  with PlusMemo1 do
    begin
    for i:= 0 to CustomKeywords.Count-1 do
      begin
      k:= CustomKeywords.KeyInfos[i];
      k.Cursor:= crHandPoint;
      CustomKeywords.KeyInfos[i]:= k
      end;
    if (Keywords=CustomKeywords) and ApplyKeywords then ReApplyKeywords
    end
end;

procedure TFrmMain.PanToolbarClick(Sender: TObject);
var i: Integer;
begin
{with PlusMemo1 do
  if UpdateMode<High(TUpdateMode) then UpdateMode:= Succ(UpdateMode)
                                  else UpdateMode:= Low(UpdateMode)}
end;


end.

